function R=decomp(Ap,A)
% performs decomposition on N for policy tables
global delta theta alpha sig B

phi=A(4);
g=A(6);
Ni=A(12);

phip=Ap(4);
gp=Ap(6);
Pp=Ap(7);
Yp=Ap(8);
Nip=Ap(12);
rlp=Ap(21);
flp=Ap(29);

%% Extensive margin- phi
Nphi=(1-delta)*gp*flp*alpha*sig*theta*(1-(phi/phip)^(1-theta))/(1-sig)/(theta-1);
%% Extensive margin- g
Ng=(1-delta)*(gp-g)*flp*alpha*sig*theta*(phi/phip)^(1-theta)/(1-sig)/(theta-1);
%% Intensive Margin
Nint=(1-delta)*g*flp*alpha*sig*theta*(phi/phip)^(1-theta)/(1-sig)/(theta-1)-Ni;

R=[(Nip-Ni)/Ni, Nphi/Ni, Ng/Ni, Nint/Ni];

end