function R=eqm_solve()
global beta phi psi sig theta 
global tk tw tau rhom rhos
global zeta gamma lambda delta Al As fe a
global Z Gamma Rl Rs
global nl ns yl ys fl ftax fs fsbar phistar phibar r rl g P Y N y0 Ni K I C
global options zerorated fixentry tauold c1 c2 u ctil eta xi
global kappa b Nd c0 zh h0 alpha B ge Inc spending

% Dependent on policy- tau, rhom, rhos
Rl=rhom+(1-rhom)*(1+tau);
fl=Rl^zeta/Al/Z;
nl=((1-zeta)*Rl/zeta)^zeta/Al;
yl=((1-zeta)*Rl/zeta)^(zeta-1)/Al;
ftax=fixentry*(((1+tauold)^zeta)/Al/Z-fl);
rl=(r+a*fl)/(1-delta);    

Rs=rhos+(1-rhos)*(1+tau);
ns=((1-gamma)*Rs/gamma)^gamma/As;
ys=((1-gamma)*Rs/gamma)^(gamma-1)/As;
fs= Rs^gamma/As/Gamma;
fsbar=fs*(1+rhos*tau*(1-gamma+gamma/Rs));
if zerorated==1 && rhos==1
    fsbar=fs;
end

% endogenous lambda
lambda=eta/(1+fsbar*(1-eta));

phistar=((fl+ftax)/fe/(1-beta*(1-delta))/(theta-1))^(1/theta);
phibar=theta*phistar/(theta-1);
P=((fl+ftax)/phistar/(1-sig))^(1-sig)*(rl^(1-alpha)/sig/B)^sig;

g = fzero(@(g) pfunc(g),[10.0^-8,3],options);
pfunc(g);

% Income
Ninc=(1-tw)*N;
Kinc=(r-phi)*(1-tk)*K+phi*K;
% Revenues
Irev=P*Y;
% Costs
Icost=sig*Irev;
% Profits
Iprof1=Irev-Icost;
Iprof2=Iprof1-(1-delta)*g*(fl+ftax);
Iprof=Iprof2-ge*fe-delta*g*(fl+ftax);

% Taxes
Tw=tw*N;
Tk=K*tk*(r-phi);
Tm=(1-rhom)*tau*yl*(g+a*K); % paid by banks (monitoring) 
Tsb=(1-rhos)*tau*ys*lambda*(1+tau)*P*C; % paid by banks (services)
Tsc=(rhos*tau*(ys+ns))*lambda*(1+tau)*P*C; % paid by consumers (services)
if zerorated==1 && rhos==1 % no VAT (effectively) collected
    Tsc=0; % paid by consumers (services)    
end
Tvat=tau*P*C;
Tfix=ftax*g;
Tax=Tw+Tk+Tm+Tsc+Tsb+Tvat;


Inc=Ninc+Kinc+Iprof+Tax+Tfix;
spending=(1+tau)*(1+lambda*fsbar)*P*C+(1-tw)*(1-N);

wel=(kappa*u^((psi-1)/psi)+(1-kappa)*c0^((psi-1)/psi))^(b*psi/(psi-1))*(1-h0-N)^(1-b);

R=[tau,rhos,rhom,phistar,phibar,g,P,Y,y0,I,N,Ni,Tw,Tk,Tm,Tsb,Tsc,Tvat,Tax,wel,rl,fsbar,Inc,fl,nl,yl,ns,ys,fl+ftax,c0,lambda];
